<html>
    <header>
        <style>
            .container{
                width: 800px;
                margin: auto;
            }
            .title-dev{
                text-align: center;
                height: 60px;
                font-size: 60px;
                font-weight: 700;
                line-height: 60px;
                margin-top: 20px;
                /* background-color: #6fa39d; */
            }
            .title-dev-1{
                display: flex;
                justify-content: space-between;
            }
            .subtitle-dev{
                font-size: 20px;
                padding-left: 4px;
                margin-top: 10px;
                background-color: #34d8e3;
                height: 40px;
                line-height: 40px;
                display: flex;
            }
            .triangle {
                width: 0;
                height: 0;
                border-left: 20px solid #0a5e80;
                border-top: 12px solid transparent;
                border-bottom: 12px solid transparent;
                margin: 8px;
            }
            .create-div{
                margin: 10px;
                display: flex;
                flex-direction: row;
                margin-bottom: 20px;
            }
            .backup-div{
                margin: 10px;
                display: flex;
                flex-direction: row;
                margin-bottom: 20px;
            }
            .progress-wrapper {
                flex-grow: 1;
                height: 40px;
                text-align: center;
                display: flex;
                flex-direction: column;
                justify-content: center;
            }
            .progress-wrapper .progress {
                background-color: #74cb7a;
                width:0%;
                height: 20px;
            }
            button{
                width: 240px;
                height: 40px;
                margin-right: 6px;
            }
            .div_margin{
                width: 20px;
            }
            .devce_info{
                width: 400px;
            }
            .devce_info div{
                margin-bottom: 6px;
            }
            .devce_info_item{
                width: 100%;
                display: flex;
            }
            .device_info_title{
                width: 100px;
                font-size: 16px;
                text-align: right;
                margin-right: 6px;
            }
            .device_info_value{
                color: gray;
                white-space: nowrap;
            }
            

            .switch {
              position: relative;
              display: inline-block;
              width: 60px;
              height: 34px;
            }

            .switch input { 
              opacity: 0;
              width: 0;
              height: 0;
            }

            .slider {
              position: absolute;
              cursor: pointer;
              top: 0;
              left: 0;
              right: 0;
              bottom: 0;
              background-color: #ccc;
              -webkit-transition: .4s;
              transition: .4s;
            }

            .slider:before {
              position: absolute;
              content: "";
              height: 26px;
              width: 26px;
              left: 4px;
              bottom: 4px;
              background-color: white;
              -webkit-transition: .4s;
              transition: .4s;
            }

            input:checked + .slider {
              background-color: #99dd98;
            }

            input:focus + .slider {
              box-shadow: 0 0 1px #99dd98;
            }

            input:checked + .slider:before {
              -webkit-transform: translateX(26px);
              -ms-transform: translateX(26px);
              transform: translateX(26px);
            }

            /* 圆形滑块 */
            .slider.round {
              border-radius: 34px;
            }

            .slider.round:before {
              border-radius: 50%;
            }

    
            [tip]:after {
              content: attr(tip);
              visibility: hidden;
              /* 实现垂直居中 */
              position: absolute;
              top: 50%;
              transform: translate(-5px, -50%);
              transition: all .3s;

              left: 100%;
              opacity: 0;

              /* 空白问题 */
              white-space: pre;
              font-size: 16px;
              padding: 5px 10px;
              background-color: rgba(18,26,44,0.8);
              color: #fff;
              box-shadow: 1px 1px 14px rgba(0,0,0,0.1)
            }
            [tip]:hover {
              /* ie兼容 */
              overflow: visible
            }
            .btn:hover:after {
              opacity: .8;
              transition: all .3s;
              transform: translate(5px, -50%);
              visibility: visible;
              display: block;
            }
        </style>
    </header>
    <body>
        <div class="container">
            <div class="title-dev" id="id_title"></div>
            <div class="title-dev-1"> 
                <div style="display: flex;">
                    <label class="switch btn" id="id_server_switch_label" tip="test">
                        <input type="checkbox" checked id="id_server_switch" onchange="doClose()">
                        <span class="slider round"></span>
                    </label>
                </div>
                <div>
                    <a href="#" id="id_locales_zh" class="locales">中文版</a> 
                    &nbsp;|&nbsp; 
                    <a href="#" id="id_locales_en" class="locales">ENGLISH</a>
                </div>
            </div>
            
            <div class="subtitle-dev">
                <div class="triangle"></div>
                <div id="id_license_title"></div>
            </div>
            %if name == 'admin':
            <div class="create-div">
                <button onclick="doCreate()" id="id_license_create"></button>
                <div class="div_margin"></div>
                <button onclick="doImport()" id="id_license_import"></button>
                <input id="id_file_license" type="file" name="data" hidden/>
                <div class="progress-wrapper">
                    <div id="progress-bar-license" class="progress"></div>
                </div>
            </div>
            %end
            <div class="backup-div">
                <button onclick="doBackup()" id="id_license_backup"></button>
                <div class="div_margin"></div>
                <input id="id_file_upload" type="file" name="data" hidden/>
                <button id="id_button_restore" onclick="doUpload()"></button>
                <div class="progress-wrapper">
                    <div id="progress-bar-file1" class="progress"></div>
                </div>
            </div>
            <div class="subtitle-dev">
                <div class="triangle"></div>
                <div id="id_deivce_title"></div>
            </div>
            <div class="backup-div">
                <div class="devce_info">
                    <div class="devce_info_item"><div class="device_info_title">Firmware:</div><div class="device_info_value" id="id_device_firmware"></div></div>
                    <div class="devce_info_item"><div class="device_info_title">Power:</div><div class="device_info_value" id="id_device_power"></div></div>
                    <button onclick="doDeviceFile()" id="id_deivce_file"></button>
                </div>
                <!-- <div class="div_margin"></div> -->
            </div>
        </div>
    </body>
    <script>
        let g_name = "{{ name }}"
        let g_info_str = "{{ info }}"
        // let g_info_str= "{ \"power\":\"255\", \"firmware\": \"hmi2120-070c\"}"
        g_info_str = g_info_str.replace(/&#039;/g,"\"")
        let g_info = JSON.parse(g_info_str)
        let locales={
            "zh": {
                "system-close": "关闭PLC配置管理",
                "system-close-warin": "关闭PLC配置管理后，该网页将无法访问",
                "title": "PLC配置管理",
                "license-title": "授权管理",
                "license-create": "创建授权key",
                "license-create-warin": "该操作会覆盖已有文件\n请谨慎操作！",
                "license-import": "导入授权",
                "license-backup": "授权备份",
                "license-restore": "授权还原",
                "device-title": "设备信息",
                "device-file": "[下载] 设备描述文件",
                "device_file_err1": "没有找到文件"
            },
            "en": {
                "system-close": "Close PLC Setting",
                "system-close-warin": "After closing PLC Setting, this page will not work.",
                "title": "PLC Setting",
                "license-title": "License Management",
                "license-create": "Create License Key",
                "license-create-warin": "This operation will overwrite the existing file!\nPlease operate with caution!",
                "license-import": "Import License",
                "license-backup": "Backup License",
                "license-restore": "Restore License",
                "device-title": "Device Info",
                "device-file": "[Download] Device Description File",
                "device_file_err1": "Not file found." 
            }
        }
        let g_local = "en";
        let g_codesys_power = {
            "117": "ED-CODESYS-TV-SM-SC",
            "118": "ED-CODESYS-WV-SM-SC",
            "124": "ED-CODESYS-SM-CNC-SC",
            "126": "ED-CODESYS-WV-SM-CNC-SC",
            "127": "ED-CODESYS-TV-WV-SM-CNC-SC",
            "240": "ED-CODESYS-MC",
            "241": "ED-CODESYS-TV-MC",
            "242": "ED-CODESYS-WV-MC",
            "243": "ED-CODESYS-TV-WV-MC",
            "245": "ED-CODESYS-TV-SM-MC",
            "246": "ED-CODESYS-WV-SM-MC",
            "252": "ED-CODESYS-SM-CNC-MC",
            "254": "ED-CODESYS-WV-SM-CNC-MC",
            "255": "ED-CODESYS-TV-WV-SM-CNC-MC"
        }
        function switch_locales(){
            if (g_local in locales){
                let local = locales[g_local]
                document.getElementById("id_title").innerHTML = local["title"];
                document.getElementById("id_license_title").innerHTML = local["license-title"];
                if(g_name == "admin"){
                    document.getElementById("id_license_create").innerHTML = local["license-create"];
                    document.getElementById("id_license_import").innerHTML = local["license-import"];
                }
                document.getElementById("id_license_backup").innerHTML = local["license-backup"];
                document.getElementById("id_button_restore").innerHTML = local["license-restore"];
                document.getElementById("id_deivce_title").innerHTML = local["device-title"];
                document.getElementById("id_deivce_file").innerHTML = local["device-file"];
                document.getElementById("id_server_switch_label").setAttribute("tip", local["system-close"]);
            }
            
        }

        function init(){
            let elements = document.getElementsByClassName("locales");
            for (var i = 0; i < elements.length; i++) {
                elements[i].addEventListener('click', function(e){
                    if(this.id == "id_locales_zh"){
                        g_local = "zh";
                    }else{
                        g_local = "en";
                    }
                    switch_locales()
                });
            }
            switch_locales(g_local)

            if("firmware" in g_info){
                document.getElementById("id_device_firmware").innerHTML = g_info["firmware"].toUpperCase()
            }
            if("power" in g_info){
                if(g_info["power"] in g_codesys_power){
                    power_value = g_codesys_power[g_info["power"]] +"("+ g_info["power"]+")";
                }else{
                    power_value = g_info["power"];
                }
                document.getElementById("id_device_power").innerHTML = power_value
            }

            var t_upload = document.getElementById("id_file_upload");
            t_upload.onchange = function(){
                uploadFile('id_file_upload', 'progress-bar-file1', "EDA_pem_backup[_0-9]*.zip", '/upload');
            }
            if(g_name == "admin"){
                var t_license = document.getElementById("id_file_license");
                t_license.onchange = function(){
                    uploadFile('id_file_license', 'progress-bar-license', ".dat$", '/license');
                }
            }
        }

        function doClose(){
            if(!document.getElementById("id_server_switch").checked){
                var r=confirm(locales[g_local]["system-close-warin"]);
                if(r == false){
                    document.getElementById("id_server_switch").checked = true
                    return;
                }
                var request = new XMLHttpRequest();
                request.open('post', '/close');
                request.timeout = 45000;
                request.send();
            }
        }

        function uploadFile(id, id_bar, t_regexp, url){
            var formdata = new FormData();
            var upload_div = document.getElementById(id);
            if(upload_div.files.length == 0){
                return;
            }
            var patt=new RegExp(t_regexp);
            if(!patt.test(upload_div.files[0].name)){
                alert("The selected file does not meet the requirements.");
                return
            }
            formdata.append('data', upload_div.files[0]);

            var request = new XMLHttpRequest();

            request.upload.addEventListener('progress', function (e) {
                var file1Size = upload_div.files[0].size;

                if (e.loaded <= file1Size) {
                    var percent = Math.round(e.loaded / file1Size * 100);
                    document.getElementById(id_bar).style.width = percent + '%';
                    document.getElementById(id_bar).innerHTML = percent + '%';
                } 

                if(e.loaded == e.total){
                    document.getElementById(id_bar).style.width = '99%';
                    document.getElementById(id_bar).innerHTML = '99%';
                }
            });   
            request.open('post', url);
            request.timeout = 45000;
            request.send(formdata);
            request.onreadystatechange = function(){
                if(request.readyState == 4 && request.status == 200){
                    document.getElementById(id_bar).style.width = '100%';
                    document.getElementById(id_bar).innerHTML = '100%';
                }
            }
        }

        function doUpload(){
            document.getElementById("id_file_upload").click();
        }

        function doBackup(){
            var request = new XMLHttpRequest();
            request.open('post', '/backup');
            request.timeout = 45000;
            request.send();
            request.onreadystatechange = function(){
                if(request.readyState == 4 && request.status == 200){
                    if(request.responseText == '-1' || request.responseText == -1){
                        alert("Backup failed!");
                    }else{
                        doDownload(request.responseText);
                    }
                }
            }
        }

        function doDownload(url){
            let t_div = document.createElement('a');
            t_div.setAttribute('href', url);
            let name = url.substring(url.lastIndexOf('/')+1)
            t_div.setAttribute('download', name);
            t_div.click();
        }

        function doCreate(){
            var r=confirm(locales[g_local]["license-create-warin"]);
            if(r == false){
                return;
            }
            var request = new XMLHttpRequest();
            request.open('post', '/create');
            request.timeout = 45000;
            request.send();
            request.onreadystatechange = function(){
                if(request.readyState == 4 && request.status == 200){
                    if(request.responseText == '-1' || request.responseText == -1){
                        alert("eda-codesys not install.");
                    }else if(request.responseText == '-2' || request.responseText == -2){
                        alert("Create pem failed.");
                    }else{
                        doDownload(request.responseText);
                    }
                }
            }
        }

        function doImport(){
            document.getElementById("id_file_license").click();
        }

        function doDeviceFile(){
            var request = new XMLHttpRequest();
            request.open('post', '/device/file');
            request.timeout = 45000;
            request.send();
            request.onreadystatechange = function(){
                if(request.readyState == 4 && request.status == 200){
                    if(request.responseText == 'device_file_err1'){
                        alert(locales[g_local]["device_file_err1"]);
                    }else{
                        doDownload(request.responseText);
                    }
                }
            }
        }

        init();
    </script>
</html>
